"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const promises_1 = require("fs/promises");
const path_1 = require("path");
exports.default = async () => {
    try {
        const rootDir = (0, child_process_1.execSync)('git rev-parse --show-toplevel', { encoding: 'utf8' }).trim();
        const metadataDir = (0, path_1.join)(rootDir, '/assets/metadata');
        const directory = await (0, promises_1.readdir)(metadataDir, { encoding: 'utf8' });
        const contents = await Promise.all(directory.map((file) => (0, promises_1.readFile)((0, path_1.join)(metadataDir, file), { encoding: 'utf8' })));
        const categories = contents
            .reduce((prev, data) => {
            const { title, topics } = JSON.parse(data);
            topics.forEach((topic) => {
                const prevRef = prev;
                if (!(topic in prev)) {
                    prevRef[topic] = [];
                }
                prevRef[topic].push(title);
            });
            return prev;
        }, {});
        await (0, promises_1.writeFile)((0, path_1.join)(rootDir, '/assets/categories.json'), JSON.stringify(categories, undefined, 2));
    }
    catch (error) {
        console.error(error);
    }
};
